/* ----------------------------------------------------------------------------
 * Copyright (c) 2017 Semiconductor Components Industries, LLC (d/b/a
 * ON Semiconductor), All Rights Reserved
 *
 * This code is the property of ON Semiconductor and may not be redistributed
 * in any form without prior written permission from ON Semiconductor.
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 *
 * This is Reusable Code.
 *
 * ------------------------------------------------------------------------- */

#ifndef IOBASE_H_
#define IOBASE_H_

#include <stdint.h>

#include "codecs/codec.h"

/* ----------------------------------------------------------------------------
 * If building with a C++ compiler, make all of the definitions in this header
 * have a C binding.
 * ------------------------------------------------------------------------- */
#ifdef __cplusplus
extern "C"
{
#endif /* ifdef __cplusplus */

typedef struct _SourceSink *pSourceSink;

typedef struct _SourceSink
{
    OperationParameters operation;

    uint32_t srcUsed;
    uint32_t snkUsed;

    void (*read)(pSourceSink source, unsigned char *buffer, uint32_t maxsize);
    void (*write)(pSourceSink sink, unsigned char *buffer, uint32_t size);
} *pSourceSink;

/* ----------------------------------------------------------------------------
 * Close the 'extern "C"' block
 * ------------------------------------------------------------------------- */
#ifdef __cplusplus
}
#endif /* ifdef __cplusplus */

#endif    /* IOBASE_H_ */
